
TRAP IT
by D. Pope
from ZX Computing Feb/Mar.1984

211400    START  LD   HL,OFFSET    ;get offset to trap from entry point
09               ADD  HL,BC        ;add entry address from BC reg pair
ED5B3D5C         LD   DE,(ERRSP)   ;get addr of stacked error return
EB               EX   DE,HL        ;HL now points at stacked error rtn
73               LD   (HL),E       ;changed stacked value to point at TRAP
23               INC  HL           ;one byte at a time
72               LD   (HL),D       ;any error will now execute TRAP
212700           LD   HL,TRAPA     ;get offset to our trap restore instruction
09               ADD  HL,BC        ;add entry address as above
73               LD   (HL),E       ;and store this into the PUSH below
23               INC  HL           ;one byte at a time
72               LD   (HL),D       ;to ensure code can be loaded anywhere
C9               RET               ;go back to BASIC, setup is finished
          ;      TRAP ROUTINE ENTERED ON ANY ERROR
210313    TRAP   LD   HL,BTRAP     ;prepare to use Spectrum error rtn
3A3A5C           LD   A,(ERRNR)    ;get the error code
3C               INC  A            ;add one to get correct value
2808             JR   Z,JUMP       ;if the BASIC opted to finish, do so
FE09             CP   9            ;error 9 is STOP, if the BASIC opted
2804             JR   Z,JUMP       ;for this then do so
FE0C             CP   12           ;error 12 (C) is NONSENSE IN BASIC, if
2001             JR   NZ,PUSH      ;we trap that we are recalled for ever
E9        JUMP   JP   (HL)         ;finish via BASIC error routine on 0, 9, 12
111400    PUSH   LD   DE,TRAP      ;this instruction is 'modified' at setup
D5               PUSH DE           ;restore our TRAP entry point for futures
21425C           LD   HL,NWPPC     ;force a 'GO TO 9900' on we return to BASIC
36AC             LD   (HL),GTOLL   ;low byte of line number 9900
23               INC  HL           ;step to NEWPPC+1
3626             LD   (HL),GTOHL   ;high byte of line number 9900
23               INC  HL           ;step to NSPPC
3601             LD   (HL),GTOST   ;statement 1 of line 9900
23               INC  HL           ;step HL to PPC, the line we trapped from
11005B           LD   DE,PRTBF     ;point DEstination at the vacant buffer
010300           LD   BC,3         ;set a byte count of 3, and save trapped
EDB0             LDIR              ;line and statement in print buffer
3A3A5C           LD   A,(ERRNR)    ;pick up error code
3C               INC  A            ;step it to give corrected value
12               LD   (DE),A       ;and save the trap code in print buffer
3EFF             LD   A,255        ;reset trap code to 0 (minus 1)
323A5C           LD   (ERRNR),A    ;and replace in error code variable
C3761B           JP   MAINL        ;return to BASIC interpreter
          ;      EQUATES
0014      OFFSET EQU  TRAP-START   ;used to create the actual TRAP address
0027      TRAPA  EQU  PUSH+1-START ;gives offset to TRAP addr in instr PUSH
1303      BTRAP  EQU  4867         ;the normal trap used by BASIC
5C42      NWPPC  EQU  23618        ;the system variable for GO TO line
5C3A      ERRNR  EQU  23610        ;system variable containing report code - 1
5B00      PRTBF  EQU  23296        ;start of printer buffer; free if no printer
0026      GTOHL  EQU  38           ;HI byte of line no 9900 = INT (9900/256)
00AC      GTOLL  EQU  172          ;LO byte of line no 9900 = 9900-256*38
0001      GTOST  EQU  1            ;statement no within line 9900
1B76      MAINL  EQU  7030         ;BASIC interpreter to continue running
5C3D      ERRSP  EQU  23613        ;pointer to stacked error return address
                 END               ;program length is 004Bh - 75 decimal


--
Another Fine Product transcribed by:
Jim Grimwood (jimg@globalnet.co.uk), Weardale, England
--
